<?php

/*

* Created 10/31/2018 by maskreet of Throwback BBS (http://www.throwbackbbs.com, telnet://bbs.throwbackbbs.com)
* Borrowed code from the original PHP Mystic Library by Frank Linhares and Darryl Perry for name and action formatting
   (Seriously, thank you guys, I couldn't figure out how to properly format the text!)
   
* Works with Mystic 1.12 A39

* I have this running in an iframe inside a table cell from my main index.html on http://www.throwbackbbs.com pointing to my BBS machine's Apache2 webserver:
* <iframe src="http://bbs.throwbackbbs.com:8081" id="online" name="online" frameborder="0" width="400" height="340" scrolling="no"></iframe>

* Any OS setup can use this, as long as you have a locally running web server and PHP to run this script

* You'll definitely have to adjust the iframe on yours (if you use one) to fully accommodate the info in this file

* -- User settings --
* $nodes = max number of nodes you run
* $headerImage = If you want to use a header image, make sure the image file is accessible to the webserver. You can use all HTML coding in it. Modify height and width to taste.
	If you don't want to use one, just set it to $headerImage = "";
* $header = The header description for each table row (node number, user name, user action)
* $defaultWFC = The default WFC status when a node isn't in use (user name, user action)
* $refreshRate = Screen refresh rate (in seconds)

* Google Fonts: https://fonts.google.com/
*
* $fontStyle = Uses Google Font; enter name of font chosen
* $fontFormat = Enter Google Font format (serif, sans-serif, monospace, etc)
* $fontSize = size of the font style
* $border = Table border on/off; use 0 or 1 for values
* $divider = text divider between header and WFC info; delete text in between "" if you don't want to use one
* $headColor = Text color for the table header
* $onColor = Text color when someone logs onto a node
* $offColor = Text color when the node is waiting for call

* $dataDir = directory where your Mystic data files are located

*/

$nodes = 5;
$headerImage = "<center><img src=\"wfc_header.png\" alt=\"\" border=3 height=90 width=360></center>";
$header = array("node", "name", "action");
$defaultWFC = array("&nbsp;---", "waiting for call");
$refreshRate = 5;

$fontStyle = "VT323";
$fontFormat = "monospace";
$fontSize = 16;
$border = 0;
$divider = "/---//-----------------//-------------------------------/";
$headColor = "#e600e6";
$onColor = "#66ff66";
$offColor = "#a6a6a6";

$dataDir = "/mystic/data/"; //ADD TRAILING SLASH!

// DON'T EDIT BELOW

chdir($dataDir);

$chats = glob('chat?{.dat}', GLOB_BRACE);

echo "<link href=\"https://fonts.googleapis.com/css?family=".$fontStyle."\" rel=\"stylesheet\">\n";
echo "<meta http-equiv=\"refresh\" content=\"".$refreshRate."\">\n";
echo "<style>\n";
echo "body {\n";
echo "\tfont-family: '".$fontStyle."', ".$fontFormat.";\n";
echo "\tfont-size: ".$fontSize."px;\n";
echo "}\n";
echo "</style>\n";
echo "</head>\n";
echo "<body>\n";
echo "<br /><br /><br />\n";
echo "<table style=\"width: 390px;\" border=\"".$border."\">\n";
echo "<tbody>\n";
if (!empty($headerImage)) {
	echo "\t<tr>\n";
	echo "\t\t<td colspan=\"3\">".$headerImage."</td>\n";
	echo "\t</tr>\n";
}
echo "\t<tr>\n";
echo "\t\t<td align=\"center\" style=\"width: 60px;\"><font color = ".$headColor.">".$header[0]."</td>\n";
echo "\t\t<td style=\"width: 117px;\"><font color = ".$headColor.">".$header[1]."</td>\n";
echo "\t\t<td style=\"width: 205px;\"><font color = ".$headColor.">".$header[2]."</td>\n";
echo "\t</tr>\n";
echo "\t<tr>\n";
echo "\t\t<td colspan=\"3\"><font color = #8c8c8c>".$divider."</td>\n";
echo "\t</tr>\n";

for ($i=1; $i <= $nodes; $i++) {

	if (in_array('chat'.$i.'.dat', $chats)) {
		
		$data = file_get_contents('chat'.$i.'.dat');

		$data_format =
			'Cactive/' .
			'Cnamelen/' .
			'A30name/' .
			'Cactionlen/' .
			'A40action/' .
			'Clocationlen/' .
			'A30location/' .
			'Agender/' .
			'Cage/' .
			'Cbaudlen/' .
			'A6baud/' .
			'cinvisible/' .
			'cavailable/' .
			'cinchat/' .
			'Croom/' ;
		    
		${'chat'.$i}[] = unpack ($data_format, $data);
		
		foreach ( ${'chat'.$i} as &$sfix ) {
			$sfix['name'] = substr($sfix['name'], 0, $sfix['namelen']);  
			$sfix['action'] = substr($sfix['action'], 0, $sfix['actionlen']); 
			$sfix['location'] = substr($sfix['location'], 0, $sfix['locationlen']);
			$sfix['baud'] = substr($sfix['baud'], 0, $sfix['baudlen']);
		}
	
		foreach ( ${'chat'.$i} as &$rfix ) {
			unset($rfix['namelen']);
			unset($rfix['actionlen']);
			unset($rfix['locationlen']);
			unset($rfix['baudlen']);
			unset($rfix['location']);
			unset($rfix['gender']);
			unset($rfix['age']);
			unset($rfix['baud']);
			unset($rfix['inchat']);
			unset($rfix['room']);
			unset($rfix['active']);
		}
	}

if (in_array('chat'.$i.'.dat', $chats) && ${'chat'.$i}[0]['invisible'] == 0) {
	
		echo "\t<tr>\n";
		echo "\t\t<td align=\"center\" style=\"width: 50px;\"><font color = ".$onColor.">".$i."</td>\n";
		echo "\t\t<td style=\"width: 217px;\"><font color = ".$onColor.">".${'chat'.$i}[0]['name']."</td>\n";
		echo "\t\t<td style=\"width: 419px;\"><font color = ".$onColor.">".${'chat'.$i}[0]['action']."</td>\n";
		echo "\t</tr>\n";
	} else {
		echo "\t<tr>\n";
		echo "\t\t<td align=\"center\" style=\"width: 50px;\"><font color = ".$offColor.">".$i."</td>\n";
		echo "\t\t<td style=\"width: 217px;\"><font color = ".$offColor.">".$defaultWFC[0]."</td>\n";
		echo "\t\t<td style=\"width: 419px;\"><font color = ".$offColor.">".$defaultWFC[1]."</td>\n";
		echo "\t</tr>\n";

	}
}

echo "</tbody>\n";
echo "</table>\n";
echo "</body>\n";
echo "</html>";	

?>